package com.yihu.hos.broker.models;

import com.yihu.hos.core.constants.CoreConstant;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

/**
 * 加载的类文件列表
 * <p>
 * Created by lingfeng on 2016/8/4.
 */
public class SystemClassMapping {
    private static Map<String, String> mapping;

    public static Map<String, String> getMapping() {
        if (mapping == null) {
            mapping = new HashMap<>();
        }
        return mapping;
    }

    public static void put(String routeCode, String packageName, String className, String type) {
        mapping.put(routeCode + type + className, packageName + CoreConstant.DOT + className);
    }

    public static String get(String routeCode, String className, String type) {
        return mapping.get(routeCode + type + className);
    }

    public static URL getResource(Object o) {
        return o.getClass().getProtectionDomain().getClassLoader().getResource("");
    }
}
